Bug 3061 - strace hangs on simple pthread program
: strace hangs on simple pthread program
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/strace)
: unstable
: all Linux
: P2 major
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2003-09-28 14:48 by
Modified: 2005-10-15 12:22 (History)


Attachments
src.rpm без собственно ipcad-2.9 (3.32 KB, application/octet-stream)
2003-09-28 15:08, Sergei Dolmatov
no flags Details
stracetest.c (373 bytes, text/x-csrc)
2003-09-28 16:48, Dmitry V. Levin
no flags Details
stracetest.c [2] (394 bytes, text/x-csrc)
2003-09-28 16:56, Dmitry V. Levin
no flags Details
stracetest.c (261 bytes, text/x-csrc)
2003-09-28 17:06, Dmitry V. Levin
no flags Details


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2003-09-28 14:48:59
buildreq вешается после запуска программы проверки наличия работоспособного
pthreads. Текст программы из ./configure:

$ cat conftest.c
#line 4164 "configure"
#include "confdefs.h"

#include <unistd.h>
#include <pthread.h>
int pid;
void
testpid(void *ignore) {
    int mypid = getpid();
    (void)ignore;
    /* All threads should have the same PID! */
    if(mypid != pid)
        exit(1);
    else
        exit(0);
}
int
main(void) {
    pthread_t child;
    pid = getpid();
    pthread_create(&child, NULL, testpid, NULL);
    pthread_join(child, NULL);
    return 1;
}

При запуске этой откомпилированной программы вручную и при обычном ./configure
все проходит нормально, возвращает 1.

Ядро: 2.4.20-alt10-up
rpm-utils-0.7.3-alt1
strace-4.4.99-alt1

Steps to Reproduce:
1. Взять и установить ipcad-2.9-alt1.src.rpm
2. Запустить buildreq ipcad.spec
------- Comment #1 From 2003-09-28 15:08:08 -------
Created an attachment (id=282) [details]
src.rpm без собственно ipcad-2.9
------- Comment #2 From 2003-09-28 16:47:31 -------
This simple pthread test fails. 
$ gcc -Wall -Werror stracetest.c -lpthread -o stracetest 
$ strace -fF ./stracetest 
 
Tested on: 
glibc-2.2.6-alt0.10 + kernel-2.2.25-alt1-smp-secure + strace-4.4-alt6 
glibc-2.2.6-alt0.10 + 2.4.20-alt10-up + strace-4.4.99-alt1 
 
------- Comment #3 From 2003-09-28 16:48:45 -------
Created an attachment (id=283) [details]
stracetest.c
------- Comment #4 From 2003-09-28 16:56:55 -------
Created an attachment (id=284) [details]
stracetest.c [2]
------- Comment #5 From 2003-09-28 17:06:21 -------
Created an attachment (id=285) [details]
stracetest.c
------- Comment #6 From 2003-09-30 15:57:14 -------
Waiting for upstream: 
https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=105994 
------- Comment #7 From 2003-10-06 11:59:40 -------
Между прочим, хоть проблема и в strace'е, тест в ipcad-2.9-alt1.src.rpm всё
равно 
кривой. 
------- Comment #8 From 2003-12-15 02:55:25 -------
Fixed in strace-4.5.1-alt1